import {invokeServer, msg, Scope} from 'yvan-ext'
import _ from 'lodash'
import vjson from "./${moduleName}.view"
import model from "./${moduleName}.model"

export default class ${moduleName} extends Scope {

    path = '${invokeUrl!""}'

    constructor() {
        super({model, vjson});
    }

    onLoad() {
    }

    grid1Select(sender, selected) {
        this.viewModel.set('${primaryKey}', selected[0]?.data?.${primaryKey})
    }

<#switch editType>
    <#case 1>
        <#break>
    <#case 2>
        add() {
            this.refs.grid1.appendEditRow({}, 1)
        }
        <#break>
    <#case 3>
        <#break>
    <#default>
</#switch>

<#if delete>
    remove() {
        this.refs.grid1.removeEditRow()
    }
</#if>

<#if editType != 1 || delete>
    save() {
        let {newRows, modifyRows, removeRecords, rows, err} = system.getGridEditRows(this.refs.grid1)
        if (err) {
            return
        }

        const primaryKey = this.viewModel.get('primaryKey')
        this.setLoading(true)
        invokeServer('${invokeUrl!''}@saveItems', {
            primaryKey,
            newRows,
            modifyRows,
            removeRecords,
        }).then(res => {
            system.msg(res.msg)
            this.refs.grid1.reload()
        }).finally(() => {
            this.setLoading(false)
        })
    }
</#if>

}

