import {invokeServer, msg, Scope} from 'yvan-ext'
import _ from 'lodash'
import vjson from "./${moduleName}.view"
import model from "./${moduleName}.model"

export default class ${moduleName} extends Scope {
    constructor() {
        super({model, vjson});
    }

    onLoad() {
    }

<#switch editType>
    <#case 1>
        <#break>
    <#case 2>
        add() {
            this.refs.grid1.appendEditRow({}, 1)
        }
        remove() {
            this.refs.grid1.removeEditRow()
        }
        save() {
            let {newRows, modifyRows, removeRecords, rows, err} = system.getGridEditRows(this.refs.grid1)
            if (err) {
                return
            }

            this.setLoading(true)
            invokeServer('/sys/dict/Dict@saveItems', {
                newRows,
                modifyRows,
                removeRecords,
            }).then(res => {
                system.msg(res.msg)
                this.refs.grid1.reload()
            }).finally(() => {
                this.setLoading(false)
            })
        }
        <#break>
    <#case 3>
        <#break>
    <#default>
</#switch>

}

